package com.yice.webadmin.app.controller;

import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.github.pagehelper.page.PageMethod;
import com.yice.webadmin.app.vo.*;
import com.yice.webadmin.app.dto.*;
import com.yice.webadmin.app.model.*;
import com.yice.webadmin.app.service.*;
import com.yice.common.core.object.*;
import com.yice.common.core.util.*;
import com.yice.common.core.constant.*;
import com.yice.common.core.annotation.MyRequestBody;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 提示词模板操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "提示词模板管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/promptTemplate")
public class PromptTemplateController {

    @Autowired
    private PromptTemplateService promptTemplateService;

    /**
     * 新增提示词模板数据。
     *
     * @param promptTemplateDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"promptTemplateDto.templateId", "promptTemplateDto.searchString"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody PromptTemplateDto promptTemplateDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(promptTemplateDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PromptTemplate promptTemplate = MyModelUtil.copyTo(promptTemplateDto, PromptTemplate.class);
        // 验证关联Id的数据合法性
        CallResult callResult = promptTemplateService.verifyRelatedData(promptTemplate, null);
        if (!callResult.isSuccess()) {
            return ResponseResult.errorFrom(callResult);
        }
        promptTemplate = promptTemplateService.saveNew(promptTemplate);
        return ResponseResult.success(promptTemplate.getTemplateId());
    }

    /**
     * 更新提示词模板数据。
     *
     * @param promptTemplateDto 更新对象。
     * @return 应答结果对象。
     */
    @ApiOperationSupport(ignoreParameters = {"promptTemplateDto.searchString"})
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody PromptTemplateDto promptTemplateDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(promptTemplateDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        PromptTemplate promptTemplate = MyModelUtil.copyTo(promptTemplateDto, PromptTemplate.class);
        PromptTemplate originalPromptTemplate = promptTemplateService.getById(promptTemplate.getTemplateId());
        if (originalPromptTemplate == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        // 验证关联Id的数据合法性
        CallResult callResult = promptTemplateService.verifyRelatedData(promptTemplate, originalPromptTemplate);
        if (!callResult.isSuccess()) {
            return ResponseResult.errorFrom(callResult);
        }
        if (!promptTemplateService.update(promptTemplate, originalPromptTemplate)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除提示词模板数据。
     *
     * @param templateId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long templateId) {
        if (MyCommonUtil.existBlankArgument(templateId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(templateId);
    }

    /**
     * 列出符合过滤条件的提示词模板列表。
     *
     * @param promptTemplateDtoFilter 过滤对象。
     * @param orderParam 排序参数。
     * @param pageParam 分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<PromptTemplateVo>> list(
            @MyRequestBody PromptTemplateDto promptTemplateDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        PromptTemplate promptTemplateFilter = MyModelUtil.copyTo(promptTemplateDtoFilter, PromptTemplate.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, PromptTemplate.class);
        List<PromptTemplate> promptTemplateList =
                promptTemplateService.getPromptTemplateListWithRelation(promptTemplateFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(promptTemplateList, PromptTemplate.INSTANCE));
    }

    /**
     * 查看指定提示词模板对象详情。
     *
     * @param templateId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<PromptTemplateVo> view(@RequestParam Long templateId) {
        PromptTemplate promptTemplate = promptTemplateService.getByIdWithRelation(templateId, MyRelationParam.full());
        if (promptTemplate == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        PromptTemplateVo promptTemplateVo = PromptTemplate.INSTANCE.fromModel(promptTemplate);
        return ResponseResult.success(promptTemplateVo);
    }

    private ResponseResult<Void> doDelete(Long templateId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        PromptTemplate originalPromptTemplate = promptTemplateService.getById(templateId);
        if (originalPromptTemplate == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!promptTemplateService.remove(templateId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
